export function $(val, id) {
    const type = val.type[0];
    const rtype = (a, b) => id.length === 1 ? a : (b + id.length);
    return {
        tag: "swizzle",
        type: type === "i"
            ? rtype("int", "ivec")
            : type === "u"
                ? rtype("uint", "uvec")
                : type === "b"
                    ? rtype("bool", "bvec")
                    : rtype("float", "vec"),
        val,
        id,
    };
}
export const $x = (val) => $(val, "x");
export const $y = (val) => $(val, "y");
export const $z = (val) => $(val, "z");
export const $w = (val) => $(val, "w");
export function $xy(val) {
    return $(val, "xy");
}
export function $xyz(val) {
    return $(val, "xyz");
}
